/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: SUBTHTOD.SQL                                                            

Descrio:                                                                 
Subtrai um determinado nmero de horas e de minutos de uma data e retorna  
a nova data.                                                               

P_DATA  - Data de referncia                                               
P_TEMPO - String contendo o numero de horas e de minutos a serem           
          subtrados da data original.                                     

Criao:                                                                   
__/__/98 - Tarciso                                                         

Manutenes:                                                               
12/08/98 - Ederson - inclusao do cabecalho com descrio da funo.        

*/

CREATE OR REPLACE
PROCEDURE SUBTHTOD_PLA(P_DATA IN DATE, P_TEMPO IN VARCHAR2, P_DTATUAL OUT DATE)
IS
   V_HORA   NUMBER;
   V_MINUTO NUMBER;
BEGIN
   V_HORA   := TO_NUMBER(SUBSTR(P_TEMPO,1,LENGTH(P_TEMPO)-2)) * (1/24);
   V_MINUTO := TO_NUMBER(SUBSTR(P_TEMPO,(LENGTH(P_TEMPO)-2)+1,2)) * (1/1440);
   V_HORA   := V_HORA+V_MINUTO;
   IF V_HORA IS NULL THEN
      V_HORA := 0;
   END IF;
   P_DTATUAL := (P_DATA - V_HORA);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SUBTHTOD_PLA','4.09.067'); END;
/

