CREATE OR REPLACE TRIGGER USR_ATU_ITEMAUTFDEST_NGD
BEFORE DELETE OR INSERT OR UPDATE OF DTPROGENTAF,
                                     QTPROGENTAF,
                                     VRPREUNIAF,
                                     IDBAIXITMAF,
                                     QTEFETENTRAF,
                                     IDBAIXITAFS



ON ITEMAUTF  FOR EACH ROW
DECLARE
  V_CDARVPROD    VARCHAR2(20) := '';
  V_CDFILIOPELOG VARCHAR2(10) := '';
  V_ERRO         VARCHAR2(300);
BEGIN
   IF DELETING THEN
      IF ((NVL(:NEW.USR_NGD_INTEGRADO, 'N') = 'S') OR (NVL(:OLD.USR_NGD_INTEGRADO, 'N') = 'S')) THEN
         SELECT NVL(MAX(CDFILIOPELOG), '')
           INTO V_CDFILIOPELOG
           FROM TIPOOPEROPL
          WHERE CDFILDEST = NVL(:OLD.CDFILDEST, :NEW.CDFILDEST)
            AND IDTIPOOPERSAID IS NOT NULL;
         SELECT NVL(MAX(PRODUTO.CDARVPROD) , '')
           INTO V_CDARVPROD
           FROM RELACPRODOL, PRODUTO
          WHERE RELACPRODOL.CDPRARVORIG    = NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO)
            AND RELACPRODOL.CDMARCA        = NVL(:OLD.CDMARCA, :NEW.CDMARCA)
            AND RELACPRODOL.CDPRODARVOL    = PRODUTO.CDPRODUTO;
         IF V_CDARVPROD = '' THEN
            SELECT NVL(MAX(PRODUTO.CDARVPROD) , '')
              INTO V_CDARVPROD
              FROM RELACPRODOL, PRODUTO
             WHERE RELACPRODOL.CDPRARVORIG    = NVL(:OLD.CDPRODUTO, :NEW.CDPRODUTO)
               AND RELACPRODOL.CDPRODARVOL    = PRODUTO.CDPRODUTO;
         END IF;
         IF (V_CDFILIOPELOG <> '' AND V_CDARVPROD <> '') THEN
            BEGIN
               UPDATE USR_ITEMAUTFDEST_NGD
                  SET QTPROGENTAF        = CASE
                                              WHEN QTPROGENTAF - NVL(:OLD.QTPROGENTAF, :NEW.QTPROGENTAF) < 0
                                              THEN 0
                                              ELSE QTPROGENTAF - NVL(:OLD.QTPROGENTAF, :NEW.QTPROGENTAF)
                                           END,
                      TPINTERFACE        = 'A',
                      DTINTERFACEORI     = SYSDATE,
                      DTINTERFACEDEST    = NULL,
                      STATUS             = '1'
                WHERE USR_ITEMAUTFDEST_NGD.CDFILIOPELOG   = V_CDFILIOPELOG
                  AND USR_ITEMAUTFDEST_NGD.CDARVPROD      = V_CDARVPROD
                  AND USR_ITEMAUTFDEST_NGD.CDFILDEST      = NVL(:OLD.CDFILDEST, :NEW.CDFILDEST)
                  AND USR_ITEMAUTFDEST_NGD.DTPROGENTAF    = TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD');
               INSERT
                 INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
               VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '0', NULL, V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||NVL(:OLD.CDFILDEST, :NEW.CDFILDEST)||'-'||TO_CHAR(:OLD.DTPROGENTAF, 'YYYYMMDD'));
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  V_ERRO       := SUBSTR(SQLERRM(SQLCODE), 1, 300);
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_ITEMAUTFDEST_NGD', SYSDATE, '1', V_ERRO,  V_CDFILIOPELOG||'-'||V_CDARVPROD||'-'||NVL(:OLD.CDFILDEST, :NEW.CDFILDEST)||'-'||TO_CHAR(NVL(:OLD.DTPROGENTAF, :NEW.DTPROGENTAF), 'YYYYMMDD'));
               END;
            END;
         END IF;
      END IF;   
   ELSIF UPDATING THEN
      IF ((NVL(:NEW.DTPROGENTAF, SYSDATE) <> NVL(:OLD.DTPROGENTAF, SYSDATE))  OR
          (NVL(:NEW.QTPROGENTAF, 0)   <> NVL(:OLD.QTPROGENTAF, 0))    OR
          (NVL(:NEW.VRPREUNIAF, 0)    <> NVL(:OLD.VRPREUNIAF, 0))     OR
          (NVL(:NEW.QTEFETENTRAF, 0)  <> NVL(:OLD.QTEFETENTRAF, 0))   OR
          (NVL(:NEW.IDBAIXITAFS, 'W') <> NVL(:OLD.IDBAIXITAFS, 'W'))  OR
          (NVL(:NEW.IDBAIXITMAF, 'W') <> NVL(:OLD.IDBAIXITMAF, 'W'))) THEN
         :NEW.USR_NGD_INTEGRADO := 'N';
      END IF;
   ELSE
     :NEW.USR_NGD_INTEGRADO   := 'N';
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_ITEMAUTFDEST_NGD','6.37.018'); END;
/
