/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMPANHIA                                                */
/* Tabela : COMPANHIA                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_COMPANHIA' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_COMPANHIA
GO

CREATE TRIGGER DTULTATU_COMPANHIA
ON COMPANHIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'COMPANHIA', null, 'CDCIA='+ CDCIA+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE COMPANHIA
      SET DTULTATUCIA = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(COMPANHIA.CDCIA,0)     = ISNULL(INSERTED.CDCIA,0)) AND
            (ISNULL(COMPANHIA.SGCIA,0)     = ISNULL(INSERTED.SGCIA,0)) AND
            (ISNULL(COMPANHIA.NMCIA,0)     = ISNULL(INSERTED.NMCIA,0)) AND
            (ISNULL(COMPANHIA.CDCLIENTE,0) = ISNULL(INSERTED.CDCLIENTE,0));
   END;
END;
GO


